#ifndef ALLTIMECONSTRAINTSFORM_TEMPLATE_H
#define ALLTIMECONSTRAINTSFORM_TEMPLATE_H

#include <qvariant.h>


#include <Qt3Support/Q3ListBox>
#include <Qt3Support/Q3MimeSourceFactory>
#include <Qt3Support/Q3TextEdit>
#include <QtCore/QVariant>
#include <QtGui/QAction>
#include <QtGui/QApplication>
#include <QtGui/QButtonGroup>
#include <QtGui/QDialog>
#include <QtGui/QGridLayout>
#include <QtGui/QHeaderView>
#include <QtGui/QLabel>
#include <QtGui/QPushButton>

QT_BEGIN_NAMESPACE

class Ui_AllTimeConstraintsForm_template
{
public:
    QGridLayout *gridLayout;
    Q3ListBox *constraintsListBox;
    QLabel *constraintsTextLabel;
    QLabel *currentConstraintTextLabel;
    Q3TextEdit *currentConstraintTextEdit;
    QPushButton *closePushButton;
    QPushButton *removeConstraintPushButton;
    QPushButton *modifyConstraintPushButton;

    void setupUi(QDialog *AllTimeConstraintsForm_template)
    {
        if (AllTimeConstraintsForm_template->objectName().isEmpty())
            AllTimeConstraintsForm_template->setObjectName(QString::fromUtf8("AllTimeConstraintsForm_template"));
        AllTimeConstraintsForm_template->resize(573, 519);
        gridLayout = new QGridLayout(AllTimeConstraintsForm_template);
        gridLayout->setSpacing(6);
        gridLayout->setMargin(11);
        gridLayout->setObjectName(QString::fromUtf8("gridLayout"));
        constraintsListBox = new Q3ListBox(AllTimeConstraintsForm_template);
        constraintsListBox->setObjectName(QString::fromUtf8("constraintsListBox"));

        gridLayout->addWidget(constraintsListBox, 1, 0, 1, 2);

        constraintsTextLabel = new QLabel(AllTimeConstraintsForm_template);
        constraintsTextLabel->setObjectName(QString::fromUtf8("constraintsTextLabel"));
        constraintsTextLabel->setFrameShape(QFrame::NoFrame);
        constraintsTextLabel->setFrameShadow(QFrame::Plain);
        constraintsTextLabel->setWordWrap(false);

        gridLayout->addWidget(constraintsTextLabel, 0, 0, 1, 2);

        currentConstraintTextLabel = new QLabel(AllTimeConstraintsForm_template);
        currentConstraintTextLabel->setObjectName(QString::fromUtf8("currentConstraintTextLabel"));
        currentConstraintTextLabel->setWordWrap(false);

        gridLayout->addWidget(currentConstraintTextLabel, 0, 2, 1, 2);

        currentConstraintTextEdit = new Q3TextEdit(AllTimeConstraintsForm_template);
        currentConstraintTextEdit->setObjectName(QString::fromUtf8("currentConstraintTextEdit"));
        currentConstraintTextEdit->setReadOnly(true);

        gridLayout->addWidget(currentConstraintTextEdit, 1, 2, 1, 2);

        closePushButton = new QPushButton(AllTimeConstraintsForm_template);
        closePushButton->setObjectName(QString::fromUtf8("closePushButton"));

        gridLayout->addWidget(closePushButton, 2, 3, 1, 1);

        removeConstraintPushButton = new QPushButton(AllTimeConstraintsForm_template);
        removeConstraintPushButton->setObjectName(QString::fromUtf8("removeConstraintPushButton"));

        gridLayout->addWidget(removeConstraintPushButton, 2, 1, 1, 2);

        modifyConstraintPushButton = new QPushButton(AllTimeConstraintsForm_template);
        modifyConstraintPushButton->setObjectName(QString::fromUtf8("modifyConstraintPushButton"));

        gridLayout->addWidget(modifyConstraintPushButton, 2, 0, 1, 1);

        QWidget::setTabOrder(constraintsListBox, modifyConstraintPushButton);
        QWidget::setTabOrder(modifyConstraintPushButton, removeConstraintPushButton);
        QWidget::setTabOrder(removeConstraintPushButton, closePushButton);
        QWidget::setTabOrder(closePushButton, currentConstraintTextEdit);

        retranslateUi(AllTimeConstraintsForm_template);
        QObject::connect(constraintsListBox, SIGNAL(highlighted(int)), AllTimeConstraintsForm_template, SLOT(constraintChanged(int)));
        QObject::connect(closePushButton, SIGNAL(clicked()), AllTimeConstraintsForm_template, SLOT(close()));
        QObject::connect(removeConstraintPushButton, SIGNAL(clicked()), AllTimeConstraintsForm_template, SLOT(removeConstraint()));
        QObject::connect(modifyConstraintPushButton, SIGNAL(clicked()), AllTimeConstraintsForm_template, SLOT(modifyConstraint()));
        QObject::connect(constraintsListBox, SIGNAL(selected(QString)), AllTimeConstraintsForm_template, SLOT(modifyConstraint()));

        QMetaObject::connectSlotsByName(AllTimeConstraintsForm_template);
    } // setupUi

    void retranslateUi(QDialog *AllTimeConstraintsForm_template)
    {
        AllTimeConstraintsForm_template->setWindowTitle(QApplication::translate("AllTimeConstraintsForm_template", "FET - All time constraints", 0, QApplication::UnicodeUTF8));
        constraintsListBox->clear();
        constraintsListBox->insertItem(QApplication::translate("AllTimeConstraintsForm_template", "New Item", 0, QApplication::UnicodeUTF8));
        constraintsTextLabel->setText(QApplication::translate("AllTimeConstraintsForm_template", "Constraints (dbl. click modifies)", 0, QApplication::UnicodeUTF8));
        currentConstraintTextLabel->setText(QApplication::translate("AllTimeConstraintsForm_template", "Current constraint", 0, QApplication::UnicodeUTF8));
        closePushButton->setText(QApplication::translate("AllTimeConstraintsForm_template", "Close", 0, QApplication::UnicodeUTF8));
        removeConstraintPushButton->setText(QApplication::translate("AllTimeConstraintsForm_template", "Remove", 0, QApplication::UnicodeUTF8));
        modifyConstraintPushButton->setText(QApplication::translate("AllTimeConstraintsForm_template", "Modify", 0, QApplication::UnicodeUTF8));
        Q_UNUSED(AllTimeConstraintsForm_template);
    } // retranslateUi

};

namespace Ui {
    class AllTimeConstraintsForm_template: public Ui_AllTimeConstraintsForm_template {};
} // namespace Ui

QT_END_NAMESPACE

class AllTimeConstraintsForm_template : public QDialog, public Ui::AllTimeConstraintsForm_template
{
    Q_OBJECT

public:
    AllTimeConstraintsForm_template(QWidget* parent = 0, const char* name = 0, bool modal = false, Qt::WindowFlags fl = 0);
    ~AllTimeConstraintsForm_template();

public slots:
    virtual void addConstraint();
    virtual void constraintChanged(int);
    virtual void removeConstraint();
    virtual void modifyConstraint();

protected slots:
    virtual void languageChange();

};

#endif // ALLTIMECONSTRAINTSFORM_TEMPLATE_H
