#ifndef GROUPSFORM_TEMPLATE_H
#define GROUPSFORM_TEMPLATE_H

#include <qvariant.h>


#include <Qt3Support/Q3ListBox>
#include <Qt3Support/Q3MimeSourceFactory>
#include <Qt3Support/Q3TextEdit>
#include <QtCore/QVariant>
#include <QtGui/QAction>
#include <QtGui/QApplication>
#include <QtGui/QButtonGroup>
#include <QtGui/QDialog>
#include <QtGui/QGridLayout>
#include <QtGui/QHeaderView>
#include <QtGui/QLabel>
#include <QtGui/QPushButton>

QT_BEGIN_NAMESPACE

class Ui_GroupsForm_template
{
public:
    QGridLayout *gridLayout;
    Q3TextEdit *groupTextEdit;
    Q3ListBox *yearsListBox;
    Q3ListBox *groupsListBox;
    QLabel *yearTextLabel;
    QLabel *groupsTextLabel;
    QPushButton *addGroupPushButton;
    QPushButton *removeGroupPushButton;
    QPushButton *modifyGroupPushButton;
    QPushButton *sortGroupsPushButton;
    QPushButton *closePushButton;
    QPushButton *activateStudentsPushButton;
    QPushButton *deactivateStudentsPushButton;
    QLabel *groupTextLabel;

    void setupUi(QDialog *GroupsForm_template)
    {
        if (GroupsForm_template->objectName().isEmpty())
            GroupsForm_template->setObjectName(QString::fromUtf8("GroupsForm_template"));
        GroupsForm_template->resize(566, 494);
        gridLayout = new QGridLayout(GroupsForm_template);
        gridLayout->setSpacing(6);
        gridLayout->setMargin(11);
        gridLayout->setObjectName(QString::fromUtf8("gridLayout"));
        groupTextEdit = new Q3TextEdit(GroupsForm_template);
        groupTextEdit->setObjectName(QString::fromUtf8("groupTextEdit"));
        groupTextEdit->setReadOnly(true);

        gridLayout->addWidget(groupTextEdit, 1, 2, 1, 1);

        yearsListBox = new Q3ListBox(GroupsForm_template);
        yearsListBox->setObjectName(QString::fromUtf8("yearsListBox"));

        gridLayout->addWidget(yearsListBox, 1, 0, 1, 1);

        groupsListBox = new Q3ListBox(GroupsForm_template);
        groupsListBox->setObjectName(QString::fromUtf8("groupsListBox"));

        gridLayout->addWidget(groupsListBox, 1, 1, 1, 1);

        yearTextLabel = new QLabel(GroupsForm_template);
        yearTextLabel->setObjectName(QString::fromUtf8("yearTextLabel"));
        yearTextLabel->setWordWrap(false);

        gridLayout->addWidget(yearTextLabel, 0, 0, 1, 1);

        groupsTextLabel = new QLabel(GroupsForm_template);
        groupsTextLabel->setObjectName(QString::fromUtf8("groupsTextLabel"));
        groupsTextLabel->setWordWrap(false);

        gridLayout->addWidget(groupsTextLabel, 0, 1, 1, 1);

        addGroupPushButton = new QPushButton(GroupsForm_template);
        addGroupPushButton->setObjectName(QString::fromUtf8("addGroupPushButton"));

        gridLayout->addWidget(addGroupPushButton, 2, 0, 1, 1);

        removeGroupPushButton = new QPushButton(GroupsForm_template);
        removeGroupPushButton->setObjectName(QString::fromUtf8("removeGroupPushButton"));

        gridLayout->addWidget(removeGroupPushButton, 2, 1, 1, 1);

        modifyGroupPushButton = new QPushButton(GroupsForm_template);
        modifyGroupPushButton->setObjectName(QString::fromUtf8("modifyGroupPushButton"));

        gridLayout->addWidget(modifyGroupPushButton, 2, 2, 1, 1);

        sortGroupsPushButton = new QPushButton(GroupsForm_template);
        sortGroupsPushButton->setObjectName(QString::fromUtf8("sortGroupsPushButton"));

        gridLayout->addWidget(sortGroupsPushButton, 3, 0, 1, 3);

        closePushButton = new QPushButton(GroupsForm_template);
        closePushButton->setObjectName(QString::fromUtf8("closePushButton"));

        gridLayout->addWidget(closePushButton, 6, 0, 1, 3);

        activateStudentsPushButton = new QPushButton(GroupsForm_template);
        activateStudentsPushButton->setObjectName(QString::fromUtf8("activateStudentsPushButton"));

        gridLayout->addWidget(activateStudentsPushButton, 4, 0, 1, 3);

        deactivateStudentsPushButton = new QPushButton(GroupsForm_template);
        deactivateStudentsPushButton->setObjectName(QString::fromUtf8("deactivateStudentsPushButton"));

        gridLayout->addWidget(deactivateStudentsPushButton, 5, 0, 1, 3);

        groupTextLabel = new QLabel(GroupsForm_template);
        groupTextLabel->setObjectName(QString::fromUtf8("groupTextLabel"));
        groupTextLabel->setWordWrap(false);

        gridLayout->addWidget(groupTextLabel, 0, 2, 1, 1);

        QWidget::setTabOrder(yearsListBox, groupsListBox);
        QWidget::setTabOrder(groupsListBox, groupTextEdit);
        QWidget::setTabOrder(groupTextEdit, addGroupPushButton);
        QWidget::setTabOrder(addGroupPushButton, removeGroupPushButton);
        QWidget::setTabOrder(removeGroupPushButton, modifyGroupPushButton);
        QWidget::setTabOrder(modifyGroupPushButton, sortGroupsPushButton);
        QWidget::setTabOrder(sortGroupsPushButton, activateStudentsPushButton);
        QWidget::setTabOrder(activateStudentsPushButton, deactivateStudentsPushButton);
        QWidget::setTabOrder(deactivateStudentsPushButton, closePushButton);

        retranslateUi(GroupsForm_template);
        QObject::connect(yearsListBox, SIGNAL(highlighted(QString)), GroupsForm_template, SLOT(yearChanged(QString)));
        QObject::connect(addGroupPushButton, SIGNAL(clicked()), GroupsForm_template, SLOT(addGroup()));
        QObject::connect(removeGroupPushButton, SIGNAL(clicked()), GroupsForm_template, SLOT(removeGroup()));
        QObject::connect(closePushButton, SIGNAL(clicked()), GroupsForm_template, SLOT(close()));
        QObject::connect(groupsListBox, SIGNAL(highlighted(QString)), GroupsForm_template, SLOT(groupChanged(QString)));
        QObject::connect(modifyGroupPushButton, SIGNAL(clicked()), GroupsForm_template, SLOT(modifyGroup()));
        QObject::connect(sortGroupsPushButton, SIGNAL(clicked()), GroupsForm_template, SLOT(sortGroups()));
        QObject::connect(activateStudentsPushButton, SIGNAL(clicked()), GroupsForm_template, SLOT(activateStudents()));
        QObject::connect(deactivateStudentsPushButton, SIGNAL(clicked()), GroupsForm_template, SLOT(deactivateStudents()));
        QObject::connect(groupsListBox, SIGNAL(selected(QString)), GroupsForm_template, SLOT(modifyGroup()));

        QMetaObject::connectSlotsByName(GroupsForm_template);
    } // setupUi

    void retranslateUi(QDialog *GroupsForm_template)
    {
        GroupsForm_template->setWindowTitle(QApplication::translate("GroupsForm_template", "FET - groups of students", 0, QApplication::UnicodeUTF8));
        yearsListBox->clear();
        yearsListBox->insertItem(QApplication::translate("GroupsForm_template", "New Item", 0, QApplication::UnicodeUTF8));
        groupsListBox->clear();
        groupsListBox->insertItem(QApplication::translate("GroupsForm_template", "New Item", 0, QApplication::UnicodeUTF8));
        yearTextLabel->setText(QApplication::translate("GroupsForm_template", "Year", 0, QApplication::UnicodeUTF8));
        groupsTextLabel->setText(QApplication::translate("GroupsForm_template", "Group", 0, QApplication::UnicodeUTF8));
        addGroupPushButton->setText(QApplication::translate("GroupsForm_template", "Add group", 0, QApplication::UnicodeUTF8));
        removeGroupPushButton->setText(QApplication::translate("GroupsForm_template", "Remove current", 0, QApplication::UnicodeUTF8));
        modifyGroupPushButton->setText(QApplication::translate("GroupsForm_template", "Modify current", 0, QApplication::UnicodeUTF8));
        sortGroupsPushButton->setText(QApplication::translate("GroupsForm_template", "Sort current groups alphabetically", 0, QApplication::UnicodeUTF8));
        closePushButton->setText(QApplication::translate("GroupsForm_template", "Close", 0, QApplication::UnicodeUTF8));
        activateStudentsPushButton->setText(QApplication::translate("GroupsForm_template", "Activate all activities for selected students group", 0, QApplication::UnicodeUTF8));
        deactivateStudentsPushButton->setText(QApplication::translate("GroupsForm_template", "De-activate all activities for selected students group", 0, QApplication::UnicodeUTF8));
        groupTextLabel->setText(QApplication::translate("GroupsForm_template", "Details", 0, QApplication::UnicodeUTF8));
        Q_UNUSED(GroupsForm_template);
    } // retranslateUi

};

namespace Ui {
    class GroupsForm_template: public Ui_GroupsForm_template {};
} // namespace Ui

QT_END_NAMESPACE

class GroupsForm_template : public QDialog, public Ui::GroupsForm_template
{
    Q_OBJECT

public:
    GroupsForm_template(QWidget* parent = 0, const char* name = 0, bool modal = false, Qt::WindowFlags fl = 0);
    ~GroupsForm_template();

public slots:
    virtual void addGroup();
    virtual void removeGroup();
    virtual void yearChanged(const QString&);
    virtual void groupChanged(const QString&);
    virtual void modifyGroup();
    virtual void sortGroups();
    virtual void activateStudents();
    virtual void deactivateStudents();

protected slots:
    virtual void languageChange();

};

#endif // GROUPSFORM_TEMPLATE_H
